import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * Write a description of class Butterfly here.
 * 
 * @author (Meagan Wolf) 
 * @version ()
 */
public class Butterfly extends Animal
{
//////////////////////Constants/////////////////////
private static final double FLYING_SPEED = 1.0;
    /**
     * Act - do whatever the Butterfly wants to do. This method is called whenever
     * the 'Act' or 'Run' button gets pressed in the environment.
     */
    public void act() 
    {
        randomMove();
        randomTurn();
        turnAtEdge();
    }   
    
    /**
     * The butterfly will move wherever it wants.
     */
  
    public void randomMove()
    {
        double angle = Math.toRadians(Greenfoot.getRandomNumber(360) );
        int x = (int) Math.round((getX() - Greenfoot.getRandomNumber(5)) + Math.cos(angle) * FLYING_SPEED);
        int y = (int) Math.round((getY() + Greenfoot.getRandomNumber(5)) + Math.sin(angle) * FLYING_SPEED);
        setLocation(x, y);
        x = (int) Math.round((getX() - Greenfoot.getRandomNumber(5)) + Math.cos(angle) * FLYING_SPEED);
        y = (int) Math.round((getY() - Greenfoot.getRandomNumber(5)) + Math.sin(angle) * FLYING_SPEED);
        setLocation(x, y);
        x = (int) Math.round((getX() + Greenfoot.getRandomNumber(5)) + Math.cos(angle) * FLYING_SPEED);
        y = (int) Math.round((getY() - Greenfoot.getRandomNumber(5)) + Math.sin(angle) * FLYING_SPEED);
        setLocation(x, y);
        x = (int) Math.round((getX() + Greenfoot.getRandomNumber(5)) + Math.cos(angle) * FLYING_SPEED);
        y = (int) Math.round((getY() + Greenfoot.getRandomNumber(5)) + Math.sin(angle) * FLYING_SPEED);
        setLocation(x, y);


    } 
    
        /**
     * Randomly decide to turn from the current direction, or not. If we turn
     * turn a bit left or right by a random degree.
     */
    public void randomTurn()
    {
        if (Greenfoot.getRandomNumber(100) > 90) {
            turn(Greenfoot.getRandomNumber(90)-45);
            randomMove();
        }
    }
    
      /**
     * Check whether we are at the edge of the world. If we are, turn a bit.
     * If not, do nothing.
     */
    public void turnAtEdge()
    {
        if ( atWorldEdge() ) 
        {
            turn(5);
           randomMove();
        }
    }
    
    /**
     * Turns the given number of degrees to the right (that is, clockwise).
     * @param angle The number of degrees this animal turns to the right.
     */
    public void turn(int angle)
    {
        setRotation(getRotation() + angle);
    }
} 
