import greenfoot. *;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.awt.Color;

/**
 * This will create the scoreboard
 * @author (Meagan Wolf)
 * @version (12/11/11)
 */
public class Scoreboard extends Actor
{
    private int score=0;
    
    /**
     * Constructs the score.
     */
    public Scoreboard()
    {    
        setImage(new GreenfootImage("Score: 0",20,Color.WHITE, Color.BLACK));
    }
    
    /**
     * Act-do whatever the scoreboard wants to do.  This method is called whenever the 'Act' or 'Run' button gets pressed in the environment.
     */
    public void act()
    {
        // Add your action code here.
    }
    
    
    /**
     * Tells how much to add to the score
     */
    void bumpScore(int amount)
    {
        score += amount;
        setImage(new GreenfootImage("Score: " + score,20,Color.WHITE, Color.BLACK));
    }
    
    /**
     * Tells what to do when all the rats are eaten.  
     */
    void gameover()
    {
        setImage(new GreenfootImage("Game Over - Final Score: " + score,20,Color.WHITE, Color.BLACK));
    }   
    
}
